package ejb31.war.servlet;

import java.io.*;
import java.net.*;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.ejb.EJB;

public class AnnotatedServlet extends HttpServlet {
   
    @EJB
    private AnnotatedEJBLocal localEJB;
    
    @EJB
    private StringService strRef;
    
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        response.setContentType("text/plain");
        PrintWriter out = response.getWriter();
        boolean status = false;
        try {
            
            out.println("-------AnnotatedServlet--------");  
            out.println("AnntatedServlet at " + request.getContextPath ());
            out.println("Local EJB:");
            out.println("@EJB="+localEJB);
            String localEJBName = null;
            if (localEJB != null) {
              localEJBName = localEJB.getName();
	      out.println("@EJB.getName()=" + localEJBName);
	      // out.println("@EJB.getDs()=" + localEJB.getDs());
	    }

            out.println("String Service Reference:");
            out.println("@EJB="+strRef);
            boolean dataTest =  strRef.isPalindrome("data");
            out.println("isPalindrome(\"data\"): " + dataTest);
            boolean edatadeTest =  strRef.isPalindrome("EDATADE");
            out.println("isPalindrome(\"EDATADE\"): " + edatadeTest);
            if ("foo".equals(localEJBName) && !dataTest && edatadeTest) {
               status = true;
	    }
        } catch (Exception ex ) {
            ex.printStackTrace();
            System.out.println("servlet test failed");
            throw new ServletException(ex);
        } finally { 
            if (status) 
	      out.println("<br>Test:Pass");
            else
	      out.println("<br>Test:Fail");
            out.close();
        }
    } 

    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    } 


    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }

    public String getServletInfo() {
        return "Short description";
    }

}
